﻿Imports ControllerDLL

Public Class Form1
    Dim LeftStick As New Windows.Vector(0, 0)
    Dim RightStick As New Windows.Vector(0, 0)

    Dim LeftTrigger As Integer
    Dim RightTrigger As Integer

    Dim Buttons As New List(Of XBox.Buttons)

    Private WithEvents XBoxController As XBox.Controller

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        XBoxController = New XBox.Controller(0, Me)
        XBoxController.StartCapturing()
    End Sub

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        XBoxController.StopCapturing()
    End Sub


    Private Sub TrackBar1_Scroll(sender As Object, e As EventArgs) Handles LeftMotorTB.Scroll
        LeftMotorLbl.Text = "Left Motor: " & LeftMotorTB.Value.ToString & "%"
    End Sub

    Private Sub TrackBar2_Scroll(sender As Object, e As EventArgs) Handles RightMotorTB.Scroll
        RightMotorLbl.Text = "Right Motor: " & RightMotorTB.Value.ToString & "%"
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles StartVibrating.Click
        XBoxController.Vibrate(LeftMotorTB.Value, RightMotorTB.Value)
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles StopVibrating.Click
        XBoxController.Vibrate(0, 0)
    End Sub

    Private Sub LeftStickSChanged(sender As Object, e As XBox.StickChangedEventArgs) Handles XBoxController.LeftStickChanged
        LeftStick = e.Vector / Short.MaxValue * 100
        PB.Refresh()
    End Sub

    Private Sub RrightStickChanged(sender As Object, e As XBox.StickChangedEventArgs) Handles XBoxController.RightStickChanged
        RightStick = e.Vector / Short.MaxValue * 100
        PB.Refresh()
    End Sub

    Private Sub LeftTriggerChanged(sender As Object, e As XBox.TriggerChangedEventArgs) Handles XBoxController.LeftTriggerChanged
        LeftTrigger = e.Value * 100 \ Byte.MaxValue
        PB.Refresh()
    End Sub

    Private Sub RightTriggerChanged(sender As Object, e As XBox.TriggerChangedEventArgs) Handles XBoxController.RightTriggerChanged
        RightTrigger = e.Value * 100 \ Byte.MaxValue
        PB.Refresh()
    End Sub

    Private Sub ButtonPressed(sender As Object, e As XBox.ButtonChangedEventArgs) Handles XBoxController.ButtonPressed
        Buttons.Add(e.ChangedButtons)
        ButtonsUpdate()
    End Sub

    Private Sub ButtonReleased(sender As Object, e As XBox.ButtonChangedEventArgs) Handles XBoxController.ButtonReleased
        Buttons.Remove(e.ChangedButtons)
        ButtonsUpdate()
    End Sub

    Private Sub ButtonsUpdate()
        Dim c As Color = Color.Red

        'DPad
        If Buttons.Contains(XBox.Buttons.UP) Then c = Color.Green Else c = Color.Red
        UpLbl.ForeColor = c
        If Buttons.Contains(XBox.Buttons.DOWN) Then c = Color.Green Else c = Color.Red
        DownLbl.ForeColor = c
        If Buttons.Contains(XBox.Buttons.LEFT) Then c = Color.Green Else c = Color.Red
        LeftLbl.ForeColor = c
        If Buttons.Contains(XBox.Buttons.RIGHT) Then c = Color.Green Else c = Color.Red
        RightLbl.ForeColor = c

        'ABXY
        If Buttons.Contains(XBox.Buttons.A) Then c = Color.Green Else c = Color.Red
        BtnA.ForeColor = c
        If Buttons.Contains(XBox.Buttons.B) Then c = Color.Green Else c = Color.Red
        BtnB.ForeColor = c
        If Buttons.Contains(XBox.Buttons.X) Then c = Color.Green Else c = Color.Red
        BtnX.ForeColor = c
        If Buttons.Contains(XBox.Buttons.Y) Then c = Color.Green Else c = Color.Red
        BtnY.ForeColor = c

        'Left/Right Buttons
        If Buttons.Contains(XBox.Buttons.LEFT_BUTTON) Then c = Color.Green Else c = Color.Red
        BtnLeft.ForeColor = c
        If Buttons.Contains(XBox.Buttons.RIGHT_BUTTON) Then c = Color.Green Else c = Color.Red
        BtnRight.ForeColor = c

        'Start/Select
        If Buttons.Contains(XBox.Buttons.START) Then c = Color.Green Else c = Color.Red
        StartLbl.ForeColor = c
        If Buttons.Contains(XBox.Buttons.SELECT) Then c = Color.Green Else c = Color.Red
        SelectLbl.ForeColor = c
    End Sub

    Private Sub PB_Paint(sender As Object, e As Windows.Forms.PaintEventArgs) Handles PB.Paint
        With e.Graphics

            Dim LSPoint As New Point(150, 300)
            Dim XOffset As New Size(10, 0)
            Dim YOffset As New Size(0, 10)
            Dim LSCross As New Size(CInt(LeftStick.X), CInt(-LeftStick.Y))

            Dim RSPoint As New Point(450, 300)
            Dim RSCross As New Size(CInt(RightStick.X), CInt(-RightStick.Y))

            Dim LTPoint As New Point(150, 150)
            Dim LTCross As New Size(0, -LeftTrigger)
            Dim RTPoint As New Point(450, 150)
            Dim RTCross As New Size(0, -RightTrigger)

            Dim Pn = Pens.Black
            Dim PnBorder = Pens.Black
            Dim PnCross = Pens.Red
            Dim PnLine = Pens.Blue

            'LStick:
            .DrawRectangle(Pn, LSPoint.X - 100, LSPoint.Y - 100, 200, 200)
            .DrawLine(PnLine, LSPoint - XOffset, LSPoint + XOffset)
            .DrawLine(PnLine, LSPoint - YOffset, LSPoint + YOffset)
            .DrawLine(PnLine, LSPoint, LSPoint + LSCross)
            .DrawLine(PnCross, LSPoint + LSCross - XOffset, LSPoint + LSCross + XOffset)
            .DrawLine(PnCross, LSPoint + LSCross - YOffset, LSPoint + LSCross + YOffset)

            'RStick:
            .DrawRectangle(Pn, RSPoint.X - 100, RSPoint.Y - 100, 200, 200)
            .DrawLine(PnLine, RSPoint - XOffset, RSPoint + XOffset)
            .DrawLine(PnLine, RSPoint - YOffset, RSPoint + YOffset)
            .DrawLine(PnLine, RSPoint, RSPoint + RSCross)
            .DrawLine(PnCross, RSPoint + RSCross - XOffset, RSPoint + RSCross + XOffset)
            .DrawLine(PnCross, RSPoint + RSCross - YOffset, RSPoint + RSCross + YOffset)

            'LTrigger:
            .DrawLine(PnBorder, LTPoint + New Size(0, -100) - XOffset, LTPoint + New Size(0, -100) + XOffset)
            .DrawLine(PnLine, LTPoint - XOffset, LTPoint + XOffset)
            .DrawLine(PnLine, LTPoint - YOffset, LTPoint + YOffset)
            .DrawLine(PnLine, LTPoint, LTPoint + LTCross)
            .DrawLine(PnCross, LTPoint + LTCross - XOffset, LTPoint + LTCross + XOffset)
            .DrawLine(PnCross, LTPoint + LTCross - YOffset, LTPoint + LTCross + YOffset)

            'RTrigger:
            .DrawLine(PnBorder, RTPoint + New Size(0, -100) - XOffset, RTPoint + New Size(0, -100) + XOffset)
            .DrawLine(PnLine, RTPoint - XOffset, RTPoint + XOffset)
            .DrawLine(PnLine, RTPoint - YOffset, RTPoint + YOffset)
            .DrawLine(PnLine, RTPoint, RTPoint + RTCross)
            .DrawLine(PnCross, RTPoint + RTCross - XOffset, RTPoint + RTCross + XOffset)
            .DrawLine(PnCross, RTPoint + RTCross - YOffset, RTPoint + RTCross + YOffset)

        End With

    End Sub

End Class
